'''
    This file is part of Full Skincolor Mod.

    Full Skincolor Mod is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Full Skincolor Mod is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Full Skincolor Mod.  If not, see <http://www.gnu.org/licenses/>.
'''

import os
import struct
def createpak(in_dir,out):
    file_address_book = []
    tsize = 0
    fpos = 12
    
    for root, dirs, files in os.walk(in_dir):
        for name in files:
            #we print this entire dir list at end
            fpath = os.path.join(root, name)
            fpath = os.path.relpath(fpath).replace("\\","/")
            fsize = os.path.getsize(fpath)
            tsize += fsize
            file_address_book.append( 
                                      {
                                        "path": fpath,
                                        "size": fsize,
                                        "pos": fpos
                                      }
                                    )
            fpos+=fsize

    #print "total files = " + str(len(file_address_book)) 
    #print "total filesize = " + str(tsize)
    header = 12 #bytes #(4c+2ints)
    dirofs = tsize + 12
    dirlen = len(file_address_book)*64
    mypakfile = bytearray(header + dirlen + tsize)
    struct.pack_into('4s',mypakfile,0,'PACK')
    struct.pack_into('<i',mypakfile,4,dirofs)
    struct.pack_into('<i',mypakfile,8,dirlen)
    for entry in file_address_book:
        with open(entry["path"], 'rb') as f:
            mypakfile[entry["pos"]:entry["pos"] + entry["size"]] = bytearray(f.read())
    index=0
    #offset = a + b + c
    for entry in file_address_book:
        #dirofs += (index * 64)
        struct.pack_into('56s',mypakfile,dirofs+0+(index*64),entry["path"])  #entry["pos"]
        struct.pack_into('<i',mypakfile,dirofs+56+(index*64),entry["pos"])
        struct.pack_into('<i',mypakfile,dirofs+60+(index*64),entry["size"])
        index+=1 
    with open(out, 'wb') as f:
        f.write(mypakfile)
