'''
    This file is part of Full Skincolor Mod.

    Full Skincolor Mod is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Full Skincolor Mod is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Full Skincolor Mod.  If not, see <http://www.gnu.org/licenses/>.
'''

import sys,ttk,math,tempfile,subprocess,platform,zipfile,os,pickle,win32api,win32con,shutil,struct,time,threading
#stop false errors - remove for debugging
sys.stderr = sys.stdout
from Tkinter import *
from tkFileDialog import askdirectory
from tkColorChooser import askcolor  

from PIL import ImageTk, TgaImagePlugin, Image

from imagestuff import *
from createpak import *
from globe import *
from soundstuff import *

#sys.stdout = open('file.txt', 'w')
#sys.stderr = open('file2.txt', 'w')

def begin():
    global rootdir,tmpfldr,pakname,root,noishead_color,body_color,weapon_color,root,armour_color
    play(noiseOk)
    root.config(cursor="wait")
    root.update()
    #extract zip files (who are in tmpfldr) to /fsm/ghoul/
    f = os.path.join(tmpfldr,'ghoulorig.zip')
    with zipfile.ZipFile(f, "r") as z:
        z.extractall(rootdir)
    f = os.path.join(tmpfldr,'soundorig.zip')
    if footstep_slider.get() != 0:
        with zipfile.ZipFile(f, "r") as z:
            z.extractall(rootdir)
    
    checkNoColor()
    ahead = head_opacity_slider.get()
    abody = body_opacity_slider.get()
    aweapon = weapon_opacity_slider.get()
    aarmour = armour_opacity_slider.get()
    ahead = float(ahead) / 100
    abody = float(abody) / 100
    aweapon = float(aweapon) / 100
    aarmour = float(aarmour) / 100

    create_base_imgs(head_color[1],body_color[1],weapon_color[1],armour_color[1],ahead,abody,aweapon,aarmour)
    #this actually takes the matching image in 'baseimgsdir' and overlays/blends it with original image
    copy_the_files(ahead,abody,aweapon,aarmour)
    if footstep_slider.get() != 0:
        create_sounds(footstep_slider.get())
    #at this point the modded files are in tmpfldr/fsm
    #we create a pak from fsm, and save in >askdirectory()<
    outpak = os.path.join(askdirectory(title="MakePAK"),pakname)
    os.chdir(rootdir)
    createpak(rootdir,outpak)
    #quit#
    root.quit()
    #delete tmpfldr
    if os.path.exists(tmpfldr):
        shutil.rmtree(tmpfldr,ignore_errors=True)

## unpack data from exe
def getfilecontents(filename):
    global file_list
    found_index = file_list.index(filename)
    f = win32api.LoadResource(0, win32con.RT_RCDATA, found_index+1)
    return f

def getthestringofspaceseperated():
    global file_list
    #string to list ahh ok.
    file_list = win32api.LoadResource(0, u'INDEX', 1).split(' ')

def writedata(filename,out):
    global tmpfldr
    data = getfilecontents(filename)
    save = os.path.join(tmpfldr,filename)
    #print "saving to: " + save
    with open(save, 'wb') as f:
        f.write(data)

#open a folder in explorer
def open_file(path):
    if platform.system() == "Windows":
        os.startfile(path)
    elif platform.system() == "Darwin":
        subprocess.Popen(["open", path])
    else:
        subprocess.Popen(["xdg-open", path])

#gui stuff
def checkNoColor():
    global head_color,body_color,weapon_color,armour_color,head_color_old,body_color_old,weapon_color_old,armour_color_old,head_color_old
    if head_color[1] == None:
        head_color = tuple(head_color_old)
    if body_color[1] == None:
        body_color = tuple(body_color_old)
    if weapon_color[1] == None:
        weapon_color = tuple(weapon_color_old)
    if armour_color[1] == None:
        armour_color = tuple(armour_color_old)

#change button color + update gui image if needed
def buttonColor(setThisGlobal):
    #buttons
    global head,body,weapon,armour,head_color_old,body_color_old,weapon_color_old,armour_color_old,head_color,body_color,weapon_color,armour_color
    if setThisGlobal == "head":
        head_color = askcolor(color=head_color_old[1],title="Head Color")
        color = head_color[1]
        button = head
    elif setThisGlobal == "body":
        body_color = askcolor(color=body_color_old[1],title="Body Color")
        color = body_color[1]
        button = body
    elif setThisGlobal == "weapon":
        weapon_color = askcolor(color=weapon_color_old[1],title="Weapon Color")
        color = weapon_color[1]
        button = weapon
    else:
        armour_color = askcolor(color=armour_color_old[1],title="Armour Color")
        color = armour_color[1]
        button = armour
    # make sure a selection was made
    checkNoColor()
    button.config(bg=color)
    tintimage("")

def setOpacitySv(val,slider):
    global svHead,svBody,svArmour,var2
    if slider == "head":
        sv = svHead
    elif slider == "body":
        sv = svBody
    elif slider == "weapon":
        sv = svWeapon
    else:
        sv = svArmour

    txt = "Opacity " + str(val) + "%"
    sv.set(txt)
    #if 'all' checkbox is set, then mirror value
    if var2.get() == 1:
        head_opacity_slider.set(val)
        abody = body_opacity_slider.set(val)
        aweapon = weapon_opacity_slider.set(val)
        aarmour = armour_opacity_slider.set(val)

def setFootstep(val):
    #also play a preview of stone1.wav
    text = "Increase Footsteps by " + str(math.trunc(float(val))) + "dB"
    footstep_lbl.set(text)
    preview_sound(int(val))


#sound on footstep slider release (footstep)
def callback(event):
    val = footstep_slider.get()
    preview_sound(int(val))

    
def tintmask(basemask,tocolour,alpha,out):
    global img
    newData = []
    img = Image.open(basemask)
    datas = img.getdata()
    for item in datas:
        #if white
        if item[0] == 255 and item[1] == 255 and item[2] == 255:
            #replace with transparency
            newData.append((255, 255, 255, 0))
        #if black
        elif item[0] == 0 and item[1] == 0 and item[2] == 0:
            new = list(tocolour)
            new.append(alpha)
            new = tuple(new)
            #change black to colour
            newData.append(new)
        else:
            newData.append(item)
    img.putdata(newData)
    img.save(out, "PNG")

#tint the gui preview image
def tintimage(e):
    global origmullins,bout,hout,wout,aout,bmask,wmask,amask,hmask,head_color,body_color,weapon_color,armour_color,finalimg,ahead_old,abody_old,aweapon_old,aarmour_old,head_color_old,body_color_old,weapon_color_old,armour_color_old,noiseSlider
    play(noiseSlider)
    ahead = head_opacity_slider.get()
    ahead = percentage(ahead)
    abody = body_opacity_slider.get()
    abody = percentage(abody)
    aweapon = weapon_opacity_slider.get()
    aweapon = percentage(aweapon)
    aarmour = armour_opacity_slider.get()
    aarmour = percentage(aarmour)

    if head_color[1] == head_color_old[1] and \
       body_color[1] == body_color_old[1] and \
       weapon_color[1] == weapon_color_old[1] and \
       armour_color[1] == armour_color_old[1] and \
       ahead == ahead_old and \
       abody == abody_old and \
       aweapon == aweapon_old and \
       aarmour == aarmour_old:
        print "nothing changed!"
    else:
        ahead_old = ahead
        abody_old = abody
        aweapon_old = aweapon
        aarmour_old = aarmour
        
        head_color_old = tuple(head_color)
        body_color_old = tuple(body_color)
        weapon_color_old = tuple(weapon_color)
        armour_color_old = tuple(armour_color)
        
        tintmask(bmask,body_color[0],abody,bout)
        tintmask(wmask,weapon_color[0],aweapon,wout)
        tintmask(amask,armour_color[0],aarmour,aout)
        tintmask(hmask,head_color[0],ahead,hout)

        alphaComp(origmullins,bout)
        alphaComp(finalimg,hout)
        alphaComp(finalimg,wout)
        alphaComp(finalimg,aout)

        im = ImageTk.PhotoImage(Image.open(finalimg))
        panel.configure(image=im)
        panel.image = im
        # im.show()
def alphaComp(background,mask):
    global finalimg
    background = Image.open(background)
    mask = Image.open(mask)
    Image.alpha_composite(background, mask).save(finalimg)

def percentage(percent):
  return int((percent * 255) / 100.0)

def clean():
    root.destroy()
    if os.path.exists(tmpfldr):
        shutil.rmtree(tmpfldr,ignore_errors=True)

#write all binary files  to tmp folder
getthestringofspaceseperated()

for filename in file_list:
    writedata(filename,tmpfldr)

root = Tk()

root.resizable(0,0)
root.protocol('WM_DELETE_WINDOW', clean)
root.wm_iconbitmap(bitmap = iconfile)
root.wm_title("SoF1 - FSM")


content = Frame(root)

svHead = StringVar()
svBody = StringVar()
svWeapon = StringVar()
footstep_lbl = StringVar()
svArmour = StringVar()

svHead.set("Opacity 100%")
svBody.set("Opacity 100%")
svWeapon.set("Opacity 100%")
svArmour.set("Opacity 100%")
footstep_lbl.set("Increase Footsteps by 50dB")

#create widgets
skinmod_lbl = Label(content, text="Full Skin-color Mod")
footmod_lbl = Label(content, text="Footstep Sound Mod")
louder_lbl = Label(content, text="Increase footsteps by 0dB")

#set button colour + tint gui image if needed
head = Button(content, text="Head", command=lambda: buttonColor("head"),bg="#F433FF")
body = Button(content, text="Body", command=lambda: buttonColor("body"),bg="lime")
weapon = Button(content, text="Weapon", command=lambda: buttonColor("weapon"),bg="red")
armour = Button(content, text="Armour", command=lambda: buttonColor("armour"),bg="yellow")

head_opacity_slider = Scale(content,orient='horizontal', from_=0, to=100,command=lambda x:setOpacitySv(x,"head"),showvalue=0, resolution=10)
head_opacity_slider.set(50)
head_opacity_lbl = Label(content, textvariable=svHead,width=12)

body_opacity_slider = Scale(content,orient='horizontal', from_=0, to=100, command=lambda x:setOpacitySv(x,"body"),showvalue=0,resolution=10)
body_opacity_slider.set(50)
body_opacity_lbl = Label(content, textvariable=svBody)

weapon_opacity_slider = Scale(content,orient='horizontal', from_=0, to=100, command=lambda x:setOpacitySv(x,"weapon"), showvalue=0,resolution=10)
weapon_opacity_slider.set(50)
weapon_opacity_lbl = Label(content, textvariable=svWeapon)

armour_opacity_slider = Scale(content,orient='horizontal', from_=0, to=100, command=lambda x:setOpacitySv(x,"armour"),showvalue=0, resolution=10)
armour_opacity_slider.set(50)
armour_opacity_lbl = Label(content, textvariable=svArmour)

footstep_slider = Scale(content,orient='horizontal', from_=0, to=16, command=setFootstep,showvalue=0,resolution=2)
footstep_slider.set(8)
footstep_slider.bind("<ButtonRelease-1>", callback)
footstep_slider_lbl = Label(content, textvariable=footstep_lbl)


content.grid(column=0, row=0)

skinmod_lbl.grid(column=0, row=0, columnspan=3)
var2 = IntVar()

Checkbutton(root, text="All", variable=var2).place(x=201, y=5)
var2.set(1)


head.grid(column=0, row=2,sticky=W+E+N+S)

head_opacity_lbl.grid(column=2, row=2)

head_opacity_slider.grid(column=1, row=2)
head_opacity_slider.bind("<ButtonRelease-1>", tintimage)

body.grid(column=0, row=3,sticky=W+E+N+S)
body_opacity_lbl.grid(column=2, row=3)
body_opacity_slider.grid(column=1, row=3)
body_opacity_slider.bind("<ButtonRelease-1>", tintimage)

weapon.grid(column=0, row=4,sticky=W+E+N+S)
weapon_opacity_lbl.grid(column=2, row=4)
weapon_opacity_slider.grid(column=1, row=4)
weapon_opacity_slider.bind("<ButtonRelease-1>", tintimage)

armour.grid(column=0, row=5,sticky=W+E+N+S)
armour_opacity_lbl.grid(column=2, row=5)
armour_opacity_slider.grid(column=1, row=5)
armour_opacity_slider.bind("<ButtonRelease-1>", tintimage)

footmod_lbl.grid(column=0, row=6, columnspan=3)
footstep_slider.grid(column=0, row=7, columnspan=3)
footstep_slider_lbl.grid(column=0, row=8, columnspan=3)

img = ImageTk.PhotoImage(Image.open(origmullins))
panel = Label(root, image = img)
panel.grid(column=3, row=0, rowspan=8)
tintimage("")

submit = Button(content, text="Ok", command=begin).grid(column=0, row=9, columnspan=3,sticky=W+E+N+S)


root.mainloop()
