'''
    This file is part of Full Skincolor Mod.

    Full Skincolor Mod is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Full Skincolor Mod is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Full Skincolor Mod.  If not, see <http://www.gnu.org/licenses/>.
'''

import os
import pickle
from globe import *
from PIL import ImageTk, TgaImagePlugin, Image
from soundstuff import *
def copy_the_files(ahead,abody,aweapon,aarmour):
    global dict_body,dict_head,dict_weapon,dict_armour,baseimgsdir
    dict_body = pickle.load( open( dict_body, "rb" ))
    dict_head = pickle.load( open( dict_head, "rb" ))
    dict_weapon = pickle.load( open( dict_weapon, "rb" ))
    dict_armour = pickle.load( open( dict_armour, "rb" ))
    for folder, subs, files in os.walk(ghouldir):
        for filename in files:
            pathname = os.path.join(folder, filename)
            mode = Image.open(pathname).mode
            if mode == "RGB":
                ext = "_RGB.tga"
            else:
                ext = "_RGBA.tga"
            if filename in dict_body:
                willItBlend(abody,filename,pathname,dict_body,"body_",ext)
            elif filename in dict_head:
                willItBlend(ahead,filename,pathname,dict_head,"head_",ext)
            elif filename in dict_weapon:
                willItBlend(aweapon,filename,pathname,dict_weapon,"weapon_",ext)
            elif filename in dict_armour:
                willItBlend(aarmour,filename,pathname,dict_armour,"armour_",ext)
            else:
                hello=1

def willItBlend(alpha,fname,pathname,fdict,header,ext):
    global baseimgsdir
    if alpha < 1.0:
        img1 = os.path.join(baseimgsdir,header + fdict[fname] + ext)
        img2 = pathname
        out = pathname
        blend(alpha,img1,img2,out)
    else:
        shutil.copyfile(os.path.join(baseimgsdir,header + "2x1.tga"),pathname)

#2x1 image if 100% alpha was chosen
def _2by1ornot2be(alpha,slist,color,header):
    global baseimgsdir
    if alpha < 1.0:
        for x in slist:
            out = os.path.join(baseimgsdir,header + replace(x))
            create_rgb_rgba(out,x,color)
    else:
        colour_img("RGB",(2,1),color,os.path.join(baseimgsdir,header + "2x1.tga"))

def create_base_imgs(clr_head,clr_body,clr_weapon,clr_armour,ahead,abody,aweapon,aarmour):
    sizes_head = [(32,64),(64,64),(128,128),(256,256),(32,16),(32,32),(64,128),(64,32)]
    sizes_body = [(128,256),(64,128),(32,32),(16,16),(32,64),(16,128),(64,64),(256,512),(16,32),(128,128)]
    sizes_weapon = [(64,32),(32,32),(32,64),(16,16)]
    sizes_armour = [(128,256), (64,64),(64,128)]
    #Create all possible sizes of image needed for head/body/armour/etc)
    if not os.path.exists(baseimgsdir):
        os.makedirs(baseimgsdir)
    _2by1ornot2be(ahead,sizes_head,clr_head,"head_")
    _2by1ornot2be(ahead,sizes_weapon,clr_weapon,"weapon_")
    _2by1ornot2be(ahead,sizes_body,clr_body,"body_")
    _2by1ornot2be(ahead,sizes_armour,clr_armour,"armour_")

def create_rgb_rgba(path,size,colour):
    #create rgb and rgba of images because blending an rgb + rgba fails
    rgb = path + "_RGB.tga"
    rgba = path + "_RGBA.tga"
    colour_img("RGBA",size,colour,rgba)
    colour_img("RGB",size,colour,rgb)

def colour_img(mode,size,colour,out):
    im = Image.new(mode, size,colour)
    im.save(out)

def replace(s):
    s = str(s).replace("(", "").replace(")","").replace(",","x").replace(" ","")
    return s

#blend 2 images
def blend(alpha,img1,img2,out):
    if alpha != 0.0:
        image1 = Image.open(img1)
        image2 = Image.open(img2)
        im = Image.blend(image2, image1, alpha)
        im.save(out)

